/**
  **********************************************************************************
  * @file      ebyte_port.h
  * @brief     EBYTEӲӿڲ ɿͻԼṩIOӿ    
  * @details   μ https://www.ebyte.com/       
  * @author    JiangHeng     
  * @date      2021-05-13     
  * @version   1.0.0     
  **********************************************************************************
  * @copyright BSD License 
  *            ɶڰصӿƼ޹˾  
  *   ______   ____   __     __  _______   ______ 
  *  |  ____| |  _ \  \ \   / / |__   __| |  ____|
  *  | |__    | |_) |  \ \_/ /     | |    | |__   
  *  |  __|   |  _ <    \   /      | |    |  __|  
  *  | |____  | |_) |    | |       | |    | |____ 
  *  |______| |____/     |_|       |_|    |______| 
  *
  **********************************************************************************
  */
#include "ebyte_port.h"


/*= !!!ĿӲƽ̨ͷļ =======================================*/
#include "board.h"  //E15-EVB02 
/*==================================================================*/

/* !
 * @brief ĿӲƽ̨SPIӿշ 
 * 
 * @param send EBYTEϲҪ 1 Byte 
 * @return SPIյ 1 Byte
 * @note Ŀƽ̨ӲSPI_NSSʱ ebyte_conf.hļ رSPI_CS(NSS)
 *       Ŀƽ̨SPI_NSSʱ Ebyte_Port_SpiCsIoControl() ĺ˵
 */
uint8e_t Ebyte_Port_SpiTransmitAndReceivce( uint8e_t send )
{
    uint8e_t result = 0;
    
    /* !ṩ: SPIӿ */
    result = Ebyte_BSP_SpiTransAndRecv( send );
    
    return result;
}

/* !
 * @brief (ѡ)ĿӲƽ̨SPI_CS(NSS) 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: CS(NSS)͵ƽ߼ź EBYTEģSPIӿΪ͵ƽѡ
 *            @arg 1: CS(NSS)ߵƽ߼ź
 * @note Ŀƽ̨ӲSPI_NSSʱļ ˺Ч
 *       Ŀƽ̨SPI_NSSʱô˺
 */
void Ebyte_Port_SpiCsIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
       /* !ѡ: SPI CS E22xxߵƽδѡ */  
       Ebyte_BSP_RfSpiUnselected(); 
    }
    else
    {
       /* !ѡ: SPI CS E22xx͵ƽѡ */  
       Ebyte_BSP_RfSpiSelected( );
    }
}

/* !
 * @brief ĿӲƽ̨λ SDN ƺ 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: NRST ͵ƽ߼ź 
 *            @arg 1: NRST ߵƽ߼ź
 * @note EBYTEģNRSTΪ͵ƽλ
 */
void Ebyte_Port_SdnIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
        /* !ṩ: SDNIO ߵƽ */
        Ebyte_BSP_E10SdnIoHigh();
    }
    else
    {
        /* !ṩ: ĿӲ·ӦSDNIO ͵ƽ */
        Ebyte_BSP_E10SdnIoLow();
    }
}


/* !
 * @brief ĿӲƽ̨ʹ BUSY ƺ 
 * 
 * @note EBYTEģBUSYΪߵƽʾæ
 */
uint8e_t Ebyte_Port_IrqIoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
    result = Ebyte_BSP_E10IrqIoRead();
    return result;
}


/* !
 * @brief ĿӲƽ̨ʹ Gpio0 ƺ 
 */
uint8e_t Ebyte_Port_Gpio0IoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
 
    return result;
}


/* !
 * @brief ĿӲƽ̨ʹ Gpio1 ƺ 
 */
uint8e_t Ebyte_Port_Gpio1IoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
   
    return result;
}

/* !
 * @brief ĿӲƽ̨ʹ Gpio1 ƺ 
 */
uint8e_t Ebyte_Port_Gpio2IoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
   
    return result;
}

/* !
 * @brief ĿӲƽ̨ʹ Gpio1 ƺ 
 */
uint8e_t Ebyte_Port_Gpio3IoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
   
    return result;
}


/* !
 * @brief ĿӲƽ̨ʱ
 * 
 * @param time ʱ 
 * @note עʱģʼʱô˺עжǷӰ쵽˺
 */
void Ebyte_Port_DelayMs( uint16e_t time )
{
    /* !ṩ: ʱ */
  
    uint16e_t i,n;
    
    while(time--)//ʾSTM8L 16MʱǰµĴʱ 
    {
        for(i=900;i>0;i--)
        {
              for( n=1 ;n>0 ;n--)
              {
                  asm("nop"); 
                  asm("nop");
                  asm("nop");
                  asm("nop");
              }
        }
    }    
}



